From 2bcbc6ecf97c003e53bfae3d4abab0e8c15d12b8 Mon Sep 17 00:00:00 2001
From: Joel Grunbaum <joelgrun@gmail.com>
Date: Sun, 29 Nov 2020 11:52:50 +0000
Subject: [PATCH] fixed comments for change

---
 main.sh |   96 +++++++++++++++++++++++++++---------------------
 1 files changed, 54 insertions(+), 42 deletions(-)

diff --git a/main.sh b/main.sh
index 6a590f4..c460d78 100755
--- a/main.sh
+++ b/main.sh
@@ -1,8 +1,12 @@
 #!/bin/bash
 #A basic bash script to automate the building of arch packages
-# Usage: main.sh init|add|build_all [-f force]
+# Usage: main.sh init|check|add|remove|build_all
 
 source $(dirname "$(realpath $0)")/vars.sh
+
+ERRORFILE=$(mktemp)
+WAITLIST=$(mktemp)
+WAITLIST_LCK=$(mktemp)
 
 #Helper for finding newest and oldest files
 #Sourced from stack overflow
@@ -43,12 +47,9 @@
 # Usage: build_pkg [package name] [-f force]
 function build_pkg {
 	#check if PKGBUILD has updated, don't rebuild if hasn't changed
-	if [[ ! -z $(git pull | grep "Already up to date.") && -z $(grep 'pkgver() {' PKGBUILD) && -z $2 ]]; then
+	if [[ -n $(git pull | grep 'Already up to date.') && -z $(grep 'pkgver() {' PKGBUILD) && -z "$2" ]]; then
 		return 2
 	fi
-
-	#remove old versions before build
-	rm -f *$1*.tar.*
 
 	#make and force rebuild if is git package
 	# Mictosoft fonts have problems with checksums and need a seperate argument
@@ -56,26 +57,40 @@
 		"$1" == "ttf-office-2007-fonts" ||
 		"$1" == "ttf-ms-win8" ||
 		"$1" == "ttf-win7-fonts" ]]; then
-		makepkg -s --noconfirm $([[ $CLEAN == "Y" ]] && echo "-c") $([[ $SIGN == "Y" ]] && echo "--sign --key $KEY") $([[ "$2" == "-f" ]] && echo -f) --skipchecksums
+		makepkg -s --noconfirm $([[ $CLEAN == "Y" ]] && echo "-c") $([[ $SIGN == "Y" ]] && echo "--sign --key $KEY") $([[ "$2" == "-f" ]] && echo -f) --skipchecksums 2>&1
 	else
 		makepkg -s --noconfirm $([[ $CLEAN == "Y" ]] && echo "-c") $([[ $SIGN == "Y" ]] && echo "--sign --key $KEY") $([[ "$2" == "-f" ]] && echo -f) 2>&1
 	fi
-	if [[ $? != 0 ]]; then
+	if [[ $? != 0  && $? != 13 ]]; then
 		#Register error
-		echo $1 >> $REPODIR/.errors
+		echo $1 >> $ERRORFILE
 		return 1
 	fi
 
+	#Remove old packages from build directory
+	source PKGBUILD
+	srcdir="$(pwd)/src"
+	ver=$(pkgver)
+	find . -mindepth 1 -maxdepth 1 -type f \( -name "*.pkg.tar.*" -o -name "*.src.tar.*" \) -not -name "*$ver-$pkgrel*" -delete
+	
 	#Get build artifact names from PKGBUILD and build artifacts
 	#Remove duplicates from the list
-	source PKGBUILD
-	pkgs=()
 	ipkgs=()
 	for i in ${pkgname[@]}; do
 		#pkgs+=("$i-$pkgver-$pkgrel")
 		ipkgs+=($(find . -mindepth 1 -maxdepth 1 -type f \( -name "$i*.pkg.tar.*" -o -name "$i*.src.tar.*" \) -not -name "*.sig" | sed 's/^\.\///'))
 	done
 	while read -r -d '' x; do pkgs+=("$x"); done < <(printf "%s\0" "${ipkgs[@]}" | sort -uz)
+
+	# Weird exceptions
+	if [[ "$1" == "zoom" ]]; then
+		rm zoom*_orig*
+		for i in ${pkgs[@]}; do
+			if [ -z "${i##*_orig*}" ]; then
+				pkgs=(${pkgs[@]/$i})
+			fi
+		done
+	fi
 
 	#Move package to repodir and add to repo db
 	#Dont change the database if rebuilt the same package at same release and version
@@ -95,55 +110,48 @@
 		return;
 	fi
 
-	# Weird exceptions
-	if [[ "$1" == "zoom" ]]; then
-		rm zoom*_orig*.pkg.tar.xz
-		for i in ${pkgs[@]}; do
-			if [ -z "${i##*orig*}" ]; then
-				pkgs=${pkgs[@]/$i}
-			fi
-		done
-	fi
-
 	# Add package to waiting list to be added to repo db
 	while true; do
-		if [[ $(cat $REPODIR/.waitlist.lck) == 1 ]]; then
+		if [[ $(cat $WAITLIST_LCK) == 1 ]]; then
 			sleep 1
 		else
-			echo 1 > $REPODIR/.waitlist.lck
-			echo $1 >> $REPODIR/.waitlist
-			echo 0 > $REPODIR/.waitlist.lck
+			echo 1 > $WAITLIST_LCK
+			echo $1 >> $WAITLIST
+			echo 0 > $WAITLIST_LCK
 			break
 			fi
 	done
 	while true; do
 		# Wait until package is at the top of the queue and add to db
-		if [[ "$(head -n1 $REPODIR/.waitlist)" == "$1" ]]; then
+		if [[ "$(head -n1 $WAITLIST)" == "$1" ]]; then
 		#	for i in ${pkgs[@]}; do
 				repo-add $([[ "$SIGN" == "Y" ]] && echo "--sign --key $KEY") $REPODIR/$REPONAME.db.tar.$([ -n "$COMPRESSION" ] || echo $COMPRESSION && echo zst) ${pkgs[@]}
 		#	done
 			while true; do
-				if [[ $(cat $REPODIR/.waitlist.lck) == 1 ]]; then
+				if [[ $(cat $WAITLIST_LCK) == 1 ]]; then
 					sleep 1
 				else
 					# Remove self from top of queue
-					echo 1 > $REPODIR/.waitlist.lck
-					tail -n +2 $REPODIR/.waitlist > $REPODIR/.waitlist.tmp
-					mv $REPODIR/.waitlist.tmp $REPODIR/.waitlist
-					echo 0 > $REPODIR/.waitlist.lck
+					echo 1 > $WAITLIST_LCK
+					TEMP=$(mktemp)
+					tail -n +2 $WAITLIST > $TEMP
+					cp $TEMP $WAITLIST
+					rm $TEMP
+					unset TEMP
+					echo 0 > $WAITLIST_LCK
 					break
 				fi
 			done
 			break
 		else
-			if [[ -z "$(grep $1 $REPODIR/.waitlist)" ]]; then
+			if [[ -z "$(grep $1 $WAITLIST)" ]]; then
 				# Not on waitlist for some reason, need to readd
-				if [[ $(cat $REPODIR/.waitlist.lck) == 1 ]]; then
+				if [[ $(cat $WAITLIST_LCK) == 1 ]]; then
 					sleep 1
 				else
-					echo 1 > $REPODIR/.waitlist.lck
-					echo $1 >> $REPODIR/.waitlist
-					echo 0 > $REPODIR/.waitlist.lck
+					echo 1 > $WAITLIST_LCK
+					echo $1 >> $WAITLIST
+					echo 0 > $WAITLIST_LCK
 				fi
 			fi
 			sleep 10
@@ -169,8 +177,6 @@
 		sudo pacman -Syu --noconfirm
 	fi
 
-	#Remove waitlist and errors from old builds
-	rm -f $REPODIR/{.waitlist,.errors}
 	#update every package currently stored
 	for d in $(find $BUILDDIR -maxdepth 1 -mindepth 1 -type d)
 	do
@@ -247,7 +253,6 @@
 	rmlist="$rmlist $(comm -12 <(pacman -Slq $REPONAME | sort) <(pacman -Slq core | sort) | tr '\n' ' ')"
 	rmlist="$rmlist $(comm -12 <(pacman -Slq $REPONAME | sort) <(pacman -Slq extra | sort) | tr '\n' ' ')"
 	rmlist="$rmlist $(comm -12 <(pacman -Slq $REPONAME | sort) <(pacman -Slq community | sort) | tr '\n' ' ')"
-	removed=()
 	TMPFILE=$(mktemp)
 	for i in $(find $BUILDDIR -mindepth 1 -maxdepth 1 -type d); do
 		check_pkg $TMPFILE "$(echo $i | rev | cut -d'/' -f1 | rev)" &
@@ -334,14 +339,19 @@
 	"check")
 		check;;
 	*)
-		printf "Invalid usage\nUsage: $0 init|add|build-all|check\n";;
+		echo -e "\033[0;31mInvalid usage\033[0m"
+		echo -e "Usage: $0 init|check|add|remove|build-all"
+		echo -e "\033[0;32minit\033[0m                        - initialise repository for use"
+		echo -e "\033[0;32mcheck\033[0m                       - check if packages have been moved into the official repositories or removed from the AUR"
+		echo -e "\033[0;32madd package ...\033[0m             - add a package to \$BUILDDIR and repository, also used to rebuild failed packages"
+		echo -e "\033[0;32mremove -a | package ...\033[0m     - remove package from \$BUILDDIR and repository, \"-a\" removes packages added to official repos"
+		echo -e "\033[0;32mbuild-all [-f]\033[0m              - build all packages in \$BUILDDIR, \"-f\" force builds whole repository"
 esac
 
 # Error reporting, send email only for build-all as assuming an batch job for that
 if [[ $1 == "build-all" || $1 == "add" ]]; then
-	if [[ -f $REPODIR/.errors ]]; then
-		ERRORS=$(cat $REPODIR/.errors | tr '\n' ' ')
-		rm $REPODIR/.errors
+	if [[ -n $(cat $ERRORFILE) ]]; then
+		ERRORS=$(cat $ERRORFILE | tr '\n' ' ')
 		echo "Errors in packages: $ERRORS"
 		if [[ "$EMAIL" != "" && "$1" == "build-all" ]]; then
 			send_email $ERRORS
@@ -350,3 +360,5 @@
 		echo "All packages built successfully"
 	fi
 fi
+
+rm $ERRORFILE $WAITLIST $WAITLIST_LCK

--
Gitblit v1.9.3